//*************************************//
// Reinforcement Learning Toolbox V.2 //
// T. AL-ANI, ASI (ESIEE)-Paris      //
// July 2004                          //
//************************************//
// RLtoolbox HomePath
set old_style on;
path=get_absolute_file_path('RLtoolbox.sce');
if MSDOS then
	check=%f;
	while ~check,
    		pathtcl='C:\\Data_tarik\\RLtoolbox_all_versions\\RLtoolbox_V.2';
    		pathtcl=x_dialog(['PATH OF THE DIRECTORY ';' ';
    		'You have already your complete path where RLtoolbox is installed?';
    		'Example: '+pathtcl;
    		'If yes Please give your path then click on OK to continue, otherwise click on Cancel';
    		'to abort.'],pathtcl);
    		if path~=[],
        		check=%t;
    		else
        		check=%f;
        		yorn();
    		end
	end
else
	pathtcl=path;
end
TK_EvalStr('set path_tcl '+pathtcl);

lines(0);

Changed_Gamma_Grid2=%f;

if exists('help_exists') == 0 	 then
	help_exists=1;
	pos=size(%helps,1);
	if MSDOS then
		//we set the help
		//DP Help
		%helps(pos,1)=path+'\methods\dp\help';
		%helps(pos,2)='Dynammic Programming for Reinforcement Learning';

		//MC Help
		%helps(pos+1,1)=path+'\methods\montecarlo\help';
		%helps(pos+1,2)='Monte Carlo for Reinforcement Learning';

		//TD Help
		%helps(pos+2,1)=path+'\methods\td\help';
		%helps(pos+2,2)='Temporal Differential for Reinforcement Learning';



	else
		//we set the help
		//DP Help
		%helps(pos+1,1)=path+'/methods/dp/help';
		%helps(pos+1,2)='Dynammic Programming for Reinforcement Learning';

		//MC Help
		%helps(pos+2,1)=path+'/methods/montecarlo/help';
		%helps(pos+2,2)='Monte Carlo for Reinforcement Learning';

		//TD Help
		%helps(pos+3,1)=path+'/methods/td/help';
		%helps(pos+3,2)='Temporal Differential for Reinforcement Learning';


	end
end

if MSDOS then
//		exec(path+'\methods\dp\examples\demo_grid1\env_grid1.txt');
		exec(path+'\methods\dp\examples\demo_grid2\env_grid2.txt');
//		exec(path+'\methods\dp\examples\demo_gambler\env_gambler.txt');
		New_Gamma_Grid2=Gamma;
		TK_EvalStr('set OS MSDOS');
		TK_EvalFile(path+'RLtoolbox.tcl');
else
//		exec(path+'/methods/dp/examples/demo_grid1/env_grid1.txt');
		exec(path+'/methods/dp/examples/demo_grid2/env_grid2.txt');
//		exec(path+'/methods/dp/examples/demo_gambler/env_gambler.txt');
		New_Gamma_Grid2=Gamma;
		TK_EvalStr('set OS UNIX');
		TK_EvalFile(path+'RLtoolbox.tcl');
end

//waiting for the interface to be exited
while %t //wait for toplevel to disapear
      TK_EvalStr('set h [winfo exists .rltoolbox]');
      if TK_GetVar("h")=='0' then break,end
end

