function Mat=list2matrix(Input)
//Function return a matrix from a list
// Input:list
//Mat: matrix

[Linput dummy]=size(Input);
if dummy~=1 then
  if Linput==1 then
    Input=Input';
    [Linput dummy]=size(Input);
  else
    printf("Matrix size incorrect: not a list\n");
    Mat=null;
    return %f
  end
end

if sqrt(Linput)~=round(sqrt(Linput)) then
  printf("Matrix size incorrect\n");
  Mat=null;
  return %f
end

width=sqrt(Linput);
Mat=zeros(width,width);

for i = 1:width
  for j = 1:width
    if Grid==1 then //Special case for grid 1 switching last value to the first
      if and([i==1, j==1]) then
	Mat(i,j)=Input(Linput-1,1);
      else
	index=(i-1)*width+(j-1);
	Mat(i,j)=Input(index,1);
      end      
    else// general case grid <> 1
      index=(i-1)*width+j;
      Mat(i,j)=Input(index,1);
    end       
  end
end   
if Grid==1 then
  Mat(width,width)=Input(Linput,1);
end
endfunction
