//***************************************//
//*   Reinforcement Learning Toolbox    *//
//*   Dynamic Programming- Demo gambler *//
//*   T. AL ANI                         *//
//*   ESIEE-ASI Paris - March 2004     *//
//***************************************//
//******************* gambler's main program **************//

function Pi=demo_gambler(path)

if MSDOS then,
exec(path+'\methods\dp\examples\demo_gambler\env_gambler.txt');
else
exec(path+'/methods/dp/examples/demo_gambler/env_gambler.txt');
end

x_message(['EXAMPLE OF THE GAMBLER';
'A gambler has the opportunity to make bets on the outcomes of a sequence of coin flips. If'; 'the coin comes up heads, then he wins as many euros as he has staked on that flip but if'; 'it is tails then he loses his stake. The game ends when the gambler wins by reaching his'; 'goal of 20 euros or loses by running out of money. On each flip, the gambler must decide'; 'what portion of his capital to stake. The state is the capital of the gambler. There are 21'; 
'states because the gambler can have between 0 and 20 euros and the actions are stakes.'])

Pi=Iter_Policy_Improv_Action_Value(NbStates,NbActions,TransProb,Rewards,Gamma,Actions_States); 

xset("window",0)
xbasc(0)

x=[1:21];
plot2d(x,Pi);

xselect()
x_message(['The results of the gambler';
'please move the Scilab window to see the graph'])
