//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Windy Grid World demonstration  *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


if MSDOS then
	getf(path+'\methods\td\examples\windygrid\MdL_edit_functions.sci');
else
	getf(path+'/methods/td/examples/WindyGrid/MdL_edit_functions.sci');
end
height=400;
width=400;

//clear the screen
TK_EvalStr('set children [winfo children .rltoolbox.f]');
TK_EvalStr('foreach i $children {destroy $i}');
TK_EvalStr('set fenetre .rltoolbox.f');

TK_EvalStr('set height '+string(height));
TK_EvalStr('set width '+string(width));
TK_EvalStr('canvas $fenetre.c -height $height -width $width -bg green');
TK_EvalStr('button $fenetre.b -text Export -command ""ScilabEval Export()""');
TK_EvalStr('pack $fenetre.c $fenetre.b -side top');


ecart_x=width/grid_width;
ecart_y=height/grid_height;

//the grid is drawed
for i=1:grid_width
	TK_EvalStr('$fenetre.c create line '+string(ecart_x*i)+' '+string(0)+' '+string(ecart_x*i)+' '+string(height));
end

for i=1:grid_height
	TK_EvalStr('$fenetre.c create line '+string(0)+' '+string(ecart_y*i)+' '+string(width)+' '+string(ecart_y*i));
end

//the wind is drawed
draw_wind();

s=TD_Mdl_first_state();

Center=Center_calc(s);
TK_EvalStr('$fenetre.c create oval '+string(Center(1)-ecart_x/2)+' '+string(Center(2)-ecart_y/2)+' '+string(Center(1)+ecart_x/2)+' '+string(Center(2)+ecart_y/2)+' -fill grey');

DRAW_TERM(Term_States);

DRAW_WALL(Obstacles);

DRAW_CLIFF(Obstacles);

DRAW_HOLE(Obstacles);

while TD_Mdl_terminal_state(s)==0
	action=find(Q(s,:)==max(Q(s,:)));
	[sprime,r]=TD_Mdl_nextstate_reward(s,action(1));
	Center_s=Center_calc(s);
	Center_sprime=Center_calc(sprime(1));
	TK_EvalStr('$fenetre.c create line '+string(Center_s(1))+' '+string(Center_s(2))+' '+string(Center_sprime(1))+' '+string(Center_sprime(2))+' -arrow last -fill darkred -width '+string(ecart_x/4));
	s=sprime;
end 
