//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Windy Grid World demonstration  *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

function Pos_center=Center_calc(State);
//on calcule le centre des grilles
	Pos_center=zeros(2,1);
	Pos_center(1,1)=ecart_x/2+modulo((State-1),grid_width)*ecart_x;
	Pos_center(2,1)=ecart_y/2+floor((State-1)/grid_width)*ecart_y;
endfunction

TK_EvalStr('set types {  {{Scilab Exec}       {.mdl}        } {{All}       {.*}        }}');
TK_EvalStr('set MODEL [tk_getOpenFile -filetypes $types -initialdir $path_tcl/methods/td/examples/windygrid/models ]');
fic=TK_GetVar('MODEL');
exec(fic);

NbEpisodesSTR='500';
NbEpisodesSTR=x_dialog('Number of episodes to simulate? '+string(NbEpisodesSTR)+' may take sometimes about 15 min.',NbEpisodesSTR);
NbEpisodes=evstr(NbEpisodesSTR);

if _algo==1 then
	Q=TD_Sarsa(NbEpisodes,Actionstates,NbStates,NbActions,Alpha,Gamma,Epsilon);
elseif _algo==2
	Q=TD_Q_learning(NbEpisodes,Actionstates,NbStates,NbActions,Alpha,Gamma,Epsilon);
elseif _algo==3
	NbIterations=NbEpisodes;
	Q=TD_R_learning(NbIterations,Actionstates,NbStates,NbActions,Alpha,Beta,Epsilon);
end

exec(path+'/methods/td/examples/WindyGrid/Display_res.sce');


