//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


if MSDOS then
	getd(path+'\methods\td\examples\tic_tac_toe\Functions\');
else
	getd(path+'/methods/td/examples/tic_tac_toe/functions/');
end
fin=%f;
//clear the screen
TK_EvalStr('set children [winfo children .rltoolbox.f]');
TK_EvalStr('foreach i $children {destroy $i}');
TK_EvalStr('set fenetre .rltoolbox.f');

//cf report of Siegel
dr=3;
dc=3;
//3 same elements to win
dwin=3;
mc=init_mc(dr,dc);

//the matrix representing the board
m=zeros(dr,dc);

if _algo==1 then

	//we load the lookuptables
	TK_EvalStr('set types {  {{Scilab Data}       {.dat}        } {{All}       {.*}        }}');
	TK_EvalStr('set MODEL [tk_getOpenFile -filetypes $types -initialdir $path_tcl/methods/td/examples/tic_tac_toe/lookuptables ]');
	fic=TK_GetVar('MODEL');
	load(fic);
	//statistics
	win_player1=0;
	win_player2=0;
	lose_player1=0;
	lose_player2=0;
	draw_games=0;

	TK_EvalStr('set fenetre [frame .rltoolbox.f.j1 -bg darkblue]');
	TK_EvalStr('pack $fenetre -side left -fill both -expand 1');
	TK_EvalStr('label $fenetre.title -text ""Joueur X :"" -bg darkred -fg darkblue');
	TK_EvalStr('radiobutton $fenetre.human -text Human -value 0 -variable j1 -bg darkblue -fg lightgrey');
	TK_EvalStr('radiobutton $fenetre.computer -text Computer -variable j1 -value 1 -bg darkblue -fg lightgrey');
	TK_EvalStr('label $fenetre.win -fg darkblue -bg lightgrey -text ""Games win :\n'+string(win_player1)+'""');
	TK_EvalStr('label $fenetre.lose -fg darkblue -bg lightgrey -text ""Games lose :\n'+string(lose_player1)+'""');
	TK_EvalStr('pack $fenetre.title $fenetre.human $fenetre.computer $fenetre.win $fenetre.lose -side top -fill both -expand 1')

	TK_EvalStr('set fenetre [frame .rltoolbox.f.ttt -bg darkblue]');
	TK_EvalStr('pack $fenetre -side left -fill both -expand 1');

	TK_EvalStr('set fenetre [frame .rltoolbox.f.j2 -bg darkblue]');
	TK_EvalStr('pack $fenetre -side left -fill both -expand 1');
	TK_EvalStr('label $fenetre.title -text ""Joueur O :"" -bg darkred -fg darkblue');
	TK_EvalStr('radiobutton $fenetre.human -text Human -variable j2 -value 0 -bg darkblue -fg lightgrey');
	TK_EvalStr('radiobutton $fenetre.computer -text Computer -variable j2 -value 1 -bg darkblue -fg lightgrey');
	TK_EvalStr('label $fenetre.win -fg darkblue -bg lightgrey -text ""Games win :\n'+string(win_player2)+'""');
	TK_EvalStr('label $fenetre.lose -fg darkblue -bg lightgrey -text ""Games lose :\n'+string(lose_player2)+'""');
	TK_EvalStr('pack $fenetre.title $fenetre.human $fenetre.computer $fenetre.win $fenetre.lose -side top -fill both -expand 1')

	//draw of the grid
	for i=1:dr
		TK_EvalStr('set fenetre [frame .rltoolbox.f.ttt.f'+string(i)+' -bg darkblue]');
		TK_EvalStr('pack $fenetre -side top -fill both -expand 1');
		for j=1:dc
			TK_EvalStr('button $fenetre.b'+string(i)+string(j)+' -activebackground darkred -disabledforeground black -fg darkblue -bg pink -font -*-times-*-*-*-*-25-*-*-*-*-*-*-* -width 5 -height 5 -state disable -command ""ScilabEval \\\[r,c,fin\\\]=click_cmd(''$fenetre.b'+string(i)+string(j)+''','+string(i)+','+string(j)+');"" ');
			TK_EvalStr('pack $fenetre.b'+string(i)+string(j)+' -side left -fill both -expand 1');
		end
	end
	TK_EvalStr('button .rltoolbox.f.ttt.b -text ""New Game"" -command ""ScilabEval \\\[win_player1,win_player2,lose_player1,lose_player2,draw_games\\\]=play(fin);"" -bg darkred -fg darkblue');
	TK_EvalStr('label .rltoolbox.f.ttt.l -fg darkblue -bg lightgrey -text ""Draw Games :\n'+string(draw_games)+'""');
	TK_EvalStr('pack .rltoolbox.f.ttt.b .rltoolbox.f.ttt.l -side top -fill x');

elseif _algo==2
	if MSDOS then
		exec(path+'\methods\td\examples\tic_tac_toe\generate_interface.sce');
	else
		exec(path+'/methods/td/examples/tic_tac_toe/generate_interface.sce');
	end

elseif _algo==3
	benchmark();
end
