//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


function [win_player1,win_player2,lose_player1,lose_player2,draw_games]=play(fin)
//nobody is a winner => winner(1)=99  winner(2)=99
winner=[99 99];

//player 1==1 <=> player X; player 2==-1 <=> player=O
m=zeros(dr,dc);
TK_EvalStr('set joueur ""X""');
player=1;

//we look the kind of players (0=Human 1=Computer)
j1=evstr(TK_GetVar('j1'));
j2=evstr(TK_GetVar('j2'));


//we  clear the buttons and color it well
for i=1:dr
	TK_EvalStr('set fenetre .rltoolbox.f.ttt.f'+string(i));
	for j=1:dc
		TK_EvalStr('$fenetre.b'+string(i)+string(j)+' configure -text """"');
		TK_EvalStr('$fenetre.b'+string(i)+string(j)+' configure -bg pink -disabledforeground black');
	end
end

//case computer versus computer
if j1==1 & j2==1 then
	//we desactivate the buttons
	for i=1:dr
		TK_EvalStr('set fenetre .rltoolbox.f.ttt.f'+string(i));
		for j=1:dc
			TK_EvalStr('$fenetre.b'+string(i)+string(j)+' configure -state disable');
		end
	end
else
//we activate the buttons
	for i=1:dr
		TK_EvalStr('set fenetre .rltoolbox.f.ttt.f'+string(i));
		for j=1:dc
			TK_EvalStr('$fenetre.b'+string(i)+string(j)+' configure -state normal');
		end
	end
end

//if j1~=0 | j2~=0 then
	cptr=0;
	while winner(1)~=-1 & winner(2)~=-1 & cptr<dr*dc
		fin=%f;
		cptr=cptr+1;
		suggest_index=dr*dc;
		//if it is the turn of the computer
		if (player==1 & j1==1) | (player==-1 & j2==1)
			if player==1 then
				suggest=comp_table(m,player,0,lookuptablepos);
			else
				suggest=comp_table(m,player,0,lookuptableneg);
			end
			while m(suggest(1,suggest_index),suggest(2,suggest_index))~=0,  // if the target is occupied
           			suggest_index=suggest_index-1;				// then take the next choice
       			end
			r=suggest(1,suggest_index);
       			c=suggest(2,suggest_index);
			fin=%t;
		end
		//wait for the click if human has to play
		while fin==%f then
		end
		m(r,c)=player;
		TK_EvalStr('.rltoolbox.f.ttt.f'+string(r)+'.b'+string(r)+string(c)+' configure -text $joueur');
		TK_EvalStr('.rltoolbox.f.ttt.f'+string(r)+'.b'+string(r)+string(c)+' configure -state disable');
		//switch of the player
		if player==-1 then
			TK_EvalStr('set joueur ""X""');
			player=1;
		else
			TK_EvalStr('set joueur ""O""')
			player=-1;
		end
		//test if a player wins
		[winner,m2]=winnertest_preframes(m,mc,dwin);
		if winner(1)==-1 | winner(2)==-1

			//draw the winning line : m2 is the matrix board without the winning line
			win=find(abs((m-m2)')==1);
			for i=1:3
				if modulo(win(1,i),3)==0
					row=3;
				else
					row=modulo(win(1,i),3);
				end
				line=ceil(win(1,i)/3);
				TK_EvalStr('.rltoolbox.f.ttt.f'+string(line)+'.b'+string(line)+string(row)+' configure -bg yellow');
			end

			if winner(1)==-1
				TK_EvalStr('tk_messageBox -title ""End of Game"" -message ""player O win"" -type ok');
				win_player1=win_player1+1;
				lose_player2=lose_player2+1;
				TK_EvalStr('.rltoolbox.f.j1.win configure -text ""Games win :\n'+string(win_player1)+'""');
				TK_EvalStr('.rltoolbox.f.j2.lose configure -text ""Games lose :\n'+string(lose_player2)+'""');
			elseif winner(2)==-1
				TK_EvalStr('tk_messageBox -title ""End of Game"" -message ""player X win"" -type ok');
				win_player2=win_player2+1;
				lose_player1=lose_player1+1;
				TK_EvalStr('.rltoolbox.f.j2.win configure -text ""Games win :\n'+string(win_player2)+'""');
				TK_EvalStr('.rltoolbox.f.j1.lose configure -text ""Games lose :\n'+string(lose_player1)+'""');

			end
		end

	end
	//if nobody wins
	if winner(1)~=-1 & winner(2)~=-1
		TK_EvalStr('tk_messageBox -title ""End of Game"" -message ""Draw"" -type ok');
		draw_games=draw_games+1;
		TK_EvalStr('.rltoolbox.f.ttt.l configure -text ""Draw Games :\n'+string(draw_games)+'""');
	end
endfunction
