//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

lookuptableneg=[0 0 .5]; // the first entry for the training data matrix
lookuptablepos=[0 0 .5]; // the first entry for the training data matrix
Reward=1;
alpha=0.7;
epsilon=0.1;
Nepisodes=1000;

//setting of the different parametres
TK_EvalStr('set main .rltoolbox.f');
TK_EvalStr('set frame [frame $main.f1]');
TK_EvalStr('label $frame.l -text ""Reward:reward of a draw game (0 or 1) :"" -fg lightgrey -bg darkblue');
TK_EvalStr('entry $frame.e -width 2 -fg lightgrey -bg darkblue');
TK_EvalStr('pack $frame.l $frame.e -side left');

TK_EvalStr('set frame [frame $main.f2]');
TK_EvalStr('label $frame.l -text ""Alpha: learn parameter (e.g. 0.2)"" -fg lightgrey -bg darkblue');
TK_EvalStr('entry $frame.e -width 4 -fg lightgrey -bg darkblue');
TK_EvalStr('pack $frame.l $frame.e -side left');

TK_EvalStr('set frame [frame $main.f3]');
TK_EvalStr('label $frame.l -text ""Epsilon: random Parameter (e.g. 0.1)"" -fg lightgrey -bg darkblue');
TK_EvalStr('entry $frame.e -width 4 -fg lightgrey -bg darkblue');
TK_EvalStr('pack $frame.l $frame.e -side left');

TK_EvalStr('set frame [frame $main.f4]');
TK_EvalStr('label $frame.l -text ""Nepisodes: number of Games to simulate (e.g. 1000)"" -fg lightgrey -bg darkblue');
TK_EvalStr('entry $frame.e -width 8 -fg lightgrey -bg darkblue');
TK_EvalStr('pack $frame.l $frame.e -side left');

TK_EvalStr('button $main.b -text Train -command ""ScilabEval tk_generate_lookuptable();""  -fg darkblue -bg darkred');

TK_EvalStr('pack $main.f1 $main.f2 $main.f3 $main.f4 $main.b -side top');

