//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*	Dynamic Programming_ Demo robot *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//
if MSDOS then
  getf(path+'\methods\dp\functions\Value_Iteration.sci');
  getf(path+'\methods\dp\functions\argPi.sci');
  getf(path+'\methods\dp\display\list2matrix.sci');
else
  getf(path+'/methods/dp/functions/Value_Iteration.sci');
  getf(path+'/methods/dp/functions/argPi.sci');
  getf(path+'/methods/dp/display/list2matrix.sci');
end

TK_EvalStr('set a [.rltoolbox.f.f1.gamma get]');
Gamma=evstr(TK_GetVar('a'));

TK_EvalStr('set a [.rltoolbox.f.f2.alpha get]');
alpha=evstr(TK_GetVar('a'))/100;

TK_EvalStr('set a [.rltoolbox.f.f3.beta get]');
beta=evstr(TK_GetVar('a'))/100;

TK_EvalStr('set a [.rltoolbox.f.f4.rs get]');
Rsearch=evstr(TK_GetVar('a'));

TK_EvalStr('set a [.rltoolbox.f.f5.rw get]');
Rwait=evstr(TK_GetVar('a'));

TK_EvalStr('set a [.rltoolbox.f.f6.rd get]');
Rdepleted=evstr(TK_GetVar('a'));

TransProb(1)=[alpha 1-alpha; 1-beta beta];

Rewards(1)=[Rsearch Rsearch; Rdepleted Rsearch];
Rewards(2)=[Rwait Rwait; Rwait Rwait];

[Pi,V]=Value_Iteration(NbStates,NbActions,TransProb,Rewards,Gamma,Actions_States);
TK_EvalStr('.rltoolbox.f.sentences configure -state normal')
TK_EvalStr('.rltoolbox.f.sentences delete 0.0 end');

if Pi(1,1)==1 then
	TK_EvalStr('set highstate ""SEARCHES""');
else if Pi(1,2)==1 then
	TK_EvalStr('set highstate ""WAITS""');
     else if Pi(1,3)==1 then
	     TK_EvalStr('set highstate ""RECHARGES""');
	  end
     end
end

if Pi(2,1)==1 then
	TK_EvalStr('set lowstate ""SEARCHES""');
else if Pi(2,2)==1 then
	TK_EvalStr('set lowstate ""WAITS""');
     else if Pi(2,3)==1 then
	     TK_EvalStr('set lowstate ""RECHARGES""');
	  end
     end
end

TK_EvalStr('.rltoolbox.f.sentences insert end ""When robot''s batteries are FULL it $highstate.\nOtherwise it $lowstate.""');
TK_EvalStr('.rltoolbox.f.sentences configure -state disabled')

