//****************************************//
//*   Reinforcement Learning Toolbox     *//
//*   MonteCarlo-BlackJack demonstration *//
//*   T. AL ANI                          *//
//*   ESIEE-ASI Paris - March 2004      *//
//****************************************//

//*************************************************//
//*                BlackJack                      *//
//*           Definition of the Model             *//
//*************************************************//

//*************************************************//
//*      Dimensions of the states matrix          *//
sx = 22;      // parameter 1 :  score of the player
sy = 11;      // parameter 2 :  card returned from the bank
_s = [sx sy]; // states liearization matrix
//*************************************************//

//*************************************************//
//*    Dimensions de la Matrice des actions       *//
ax = 2;    // parameter 1 :  Player: Draw a card, stop
_a = [ax]; // actions liearization matrix
//*************************************************//

//*************************************************//
//*           Boolean matrix A(s,a)               *//
//*    of the possible actions for each state     *//
A = zeros(sx, sy, ax);  // Initialization = no action is authorized
A( 1:20, 1:11, 1:2) = 1;
A(21:22, 1:11,   1) = 1;
//*************************************************//


