//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   MonteCarlo                      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

//***************************************************************//
//*                  Reinforcement Learning                     *//
//*                     Benchmark Policy                        *//
//***************************************************************//


SimulateStr='100';
SimulateStr = x_dialog("Number of episodes to simulate ",SimulateStr);
Simulate=evstr(SimulateStr);

TK_EvalStr('if [winfo exists .pliz_wait]==1 {	destroy .pliz_wait	}');
TK_EvalStr('toplevel .pliz_wait');
TK_EvalStr('wm title .pliz_wait ""Benchmark Policy""');
TK_EvalStr('label .pliz_wait.l -text ""Please Wait a little ...\n 0% done""');
TK_EvalStr('pack .pliz_wait.l -fill both');

But = 0;
Succes_tab=zeros(Simulate,1);
for loop=1:Simulate

  // Create an episode
  Episode = Mc_Creat_Episode(Pi, Actionlist);

  // Check if the goal were reached 
  But = But + Mdl_Check_Goal(Episode);
  if loop>2 then
    Succes_tab(loop,1) = (But*100)/loop;
  end

  TK_EvalStr('.pliz_wait.l configure -text ""Please Wait a little ...\n'+string((loop/Simulate)*100)+'% done""');
end
Succes = (But*100)/Simulate;

TK_EvalStr('.pliz_wait.l configure -text ""Success = '+string(Succes)+'%""');
xbasc();plot2d([1:Simulate],Succes_tab,,"181","Success Percentage");
//***************************************************************//

