//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Random Walk demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


function V=MC_alpha_constant(NbEpisodes,NbStates,NbActions,Alpha,Gamma)

V=zeros(NbStates,1); // Arbitrary initialisation

for i=1:NbEpisodes                // for each episode
  R=0;
  s=TD_Mdl_first_state();                  //first state s
  States=list();
  States(1)=s;
  cptr=1;
  while TD_Mdl_terminal_state(s)==%f

    a=TD_Mdl_Policy(s);                            //action given by pi for s
    [sprime , r_tmp]=TD_Mdl_nextstate_reward(s,a);      //observe state s' (next step state)
    R= R+r_tmp;             //observe reward

    s=sprime;
    cptr=cptr+1;
    States(cptr)=s;


  end
  for i=1:length(States)
  	s=States(i);
  	V(s) = V(s) + Alpha * (R - V(s) );
  end

end

endfunction
