//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


function Stats(Results,contin)

Victoires_cum=Results(:,[2 3 4]);// cummulative victory
Victoires=Victoires_cum;
iterations=size(Victoires_cum,1)*10-contin;
for i=1:(iterations/10)
  Victoires(i,:)=100*Victoires_cum(i,:)/(i*10);

end
xbasc();
xclear();
xsetech([0,0,0.5,1]);
xtitle('Games won during learning','Episodes (x 10)','Percentage');	
plot2d([1:iterations/10],Victoires([1:iterations/10],:),,,'Game won by player +1@Draw@Game won by player -1');

xsetech([0.5,0,0.5,1]);
xtitle('Number of states browsed by each player during training','Episodes (x 10)','States');
plot2d([1:iterations/10],Results([1:iterations/10],[5 6]),,,'Player +1@Player -1');

endfunction